<template>
  <div class="accordion" v-for="info in accordion_informations" :key="info.id">
    <button class="accordion-button">
      {{ info.headline }}
    </button>
    <div class="accordion-text" v-html="info.text"></div>
  </div>
</template>

<script>
export default {
  name: "Accordion",
  data: function () {
    return {
      accordion_informations: [
        {
          id: 9,
          headline: "Was haben soziale Netzwerke mit Graphen zu tun?",
          text: "Soziale Netzwerke können als Graph dargestellt werden: Die <b>Knoten</b> (dargestellt als Kreise) eines Graphs repräsentieren die <b>Teilnehmer</b> eines sozialen Netzwerks und eine <b>Kante</b> (dargestellt als Linien zwischen den Kreisen) repräsentiert eine <b>Beziehung oder Interaktion</b> zwischen zwei Teilnehmern des sozialen Netzwerks.",
        },
        {
          id: 10,
          headline: "Was ist die grundlegende Arbeitsweise der Algorithmen in dieser Anwendung?",
          text: '<p>Die Grundlegende Arbeitsweise der in dieser Anwendung wählbaren Algorithmen ist für alle Algorithmen gleich:</p><ol><li><b>Berechne einen Score</b> für alle Knotenpaare (zwischen denen noch keine Kante existiert - dieser Score muss nicht für alle möglichen Knotenpaare berechnet werden, da ja die Entstehung von Kanten vorhergesagt werden soll. Existiert bereits eine Kante zwischen zwei Knoten dann kann zwischen diesen keine weitere Kante mehr entstehen.) <br />Die Berechnung des Scores kann dabei auf drei verschiedenen Merkmalen des Graphen basieren:<ol type="a"><li><b>Nachbarschaftsbeziehungen</b></li><li><b>Pfaden</b></li><li><b>Random Walks</b></li></ol></li><p></p><li><b>Entscheide</b>, zwischen welchen Knoten eine <b>Kante entstehen</b> wird und zwischen welchen nicht. Dafür gibt es die beiden folgenden Möglichkeiten:<ol type="a"><li>Wähle die Knotenpaare, für die die Entstehung einer Kante vorhergesagt wird, mit Hilfe eines <b>Thresholds</b></li><li>Verwende <b>Machine Learning</b> um die Vorhersagen zu treffen</li></ol>Da Möglichkeit b deutlich komplexer zu verstehen ist als Möglichkeit a wird sich in dieser Software auf das Vorhersagen von Kantenentstehungen mittels eines Threshold beschränkt.</li></ol>',
        },
        {
          id: 0,
          headline: "Was ist eine Nachbarschaftsbeziehung?",
          text: "Zwei Knoten x und y sind miteinander <b>benachbart</b>, wenn es eine <b>Kante</b> gibt, die <b>x und y verbindet</b>.",
        },
        {
          id: 1,
          headline: "Was ist ein Pfad?",
          text: "Ein <n>Pfad der Länge n</n> ist eine <b>Folge von n+1 miteinander verbundenen Knoten</b>.<br> Beispiel: Der Pfad <b>p = (a, b, c, d, e)</b> ist ein Pfad der Länge 4. Der Knoten a ist hier mit dem Knoten b verbunden, der Konten b ist mit dem Knoten c verbunden usw.",
        },
        {
          id: 2,
          headline: "Was ist ein Random Walk?",
          text: "Bei einem Random Walk durch einen Graphen <b>ausgehend von einem Knoten s</b> mit einem <b>Knoten z als Ziel</b> wird zunächst <b>zufällig</b> ein Nachbar von s gewählt. Von diesem Nachbarn ausgehend wird erneut <b>zufällig</b> ein Nachbar gewählt. Dieses Vorgehen wiederholt sich immer weiter, bis der zufällig gewählte Nachbar der Knoten z ist",
        },
        {
          id: 3,
          headline: "Was ist ein Threshold?",
          text: "Ein Threshold (im Deutschen 'Schwellwert') ist eine Zahl, mithilfe derer ein Algorithmus zur Kantenvorhersage entscheidet, für welche Knotenpaare er die Entstehung einer Kante vorhersagt und für welche nicht. <br>Dafür wird der Score, der für ein Knotenpaar berechnet wurde, mit dem Threshold verglichen. Ist dann der Score kleiner oder größer als der Threshold wird je nach Algorithmus die Entstehung einer Kante vorhergesagt oder nicht.",
        },
        {
          id: 4,
          headline: "Wie kann ich einen Threshold festlegen?",
          text: "Der beste mögliche Threshold für einen Algorithmus in einem konkreten Netzwerk kann beispielsweise mit Hilfe der dazugehörigen ROC-Kurve berechnet werden. <br>Ein optimaler Threshold kann beispielsweise so definiert werden, dass mit ihm eine <b>möglichst hohe True Positive Rate (TPR)</b> erreicht wird bei einer gleichzeitig <b>möglichst geringen False Positive Rate (FPR)</b>. Daher kann man für jeden Punkt der ROC-Kurve die Differenz aus FPR und TPR bilden. Der Threshold, für den das Ergebnis dieser Differenz maximal ist, ist der optimale Threshold.",
        },
        {
          id: 5,
          headline: "Was ist eine ROC-Kurve?",
          text: "Mit einer ROC-Kurve lässt sich veranschaulichen wie gut eine Kantenvorhersage mit einem ausgewählten Algorithmus auf einem Netzwerk funktioniert. ROC steht für <b>'Receiver Operating Characteristic'</b>. Um eine ROC-Kurve zu erstellen werden folgende Werte benötigt: True-Positive-Rate (TPR) und False-Positive-Rate (FPR). Um die ROC-Kurve zu erhalten werden <b>TPR und FPR für verschiedene Thresholds</b> ermittelt. Dann wird für jeden Threshold die <b>FPR (an der x-Achse)</b> gegen die <b>TPR (an der y-Achse)</b> angetragen und die Punkte miteinander verbunden.",
        },
        {
          id: 6,
          headline: "Was beschreibt eine True-Positive-Rate (TPR)?",
          text: "Die TPR gibt an, wie viele der tatsächlich in Zukunft existierenden Kanten als entstehende Kanten vorhergesagt wurden.",
        },
        {
          id: 7,
          headline: "Was beschreibt eine False-Positive-Rate (FPR)?",
          text: "Die FPR gibt an wie viele der in Zukunft tatsächlich nicht existierenden Kanten fälschlicherweise als entstehende Kanten vorhergesagt wurden.",
        },
        {
          id:8,
          headline: "Weiterführende Informationen zu den Maßen, die unter dem Graph angezeigt werden",
          text: "Centrality und Centralisation:<ul><li>Der Artikel: <a href=\"https://downloads.hindawi.com/archive/2014/241723.pdf#page=1\">Betweenness Centrality in Some Classes of Graphs</a></li><li>Das Paper: <a href=\"https://www.bebr.ufl.edu/sites/default/files/Centrality%20in%20Social%20Networks.pdf#page=1\">Centrality in Social Networks Conceptual Clarification </a></li><li>Kapitel 1 des Buchs: <a href=\"https://rd.springer.com/content/pdf/10.1007%2F978-981-16-3398-0.pdf#page=15\"</li>Principles of Social Networking</a></li></ul><br><br>Effective Size:<ul><li>Das Paper: <a href=\"https://www.researchgate.net/publication/281206574_Structural_Holes/link/55db283b08aec156b9af963a/download\">Structural Holes</a></li></ul>"
        }
      ],
    };
  },
  mounted: function () {
    var accordions = document.getElementsByClassName("accordion-button");
    for (var i = 0; i < accordions.length; i++) {
      accordions[i].addEventListener("click", function () {
        this.classList.toggle("active");

        var accordionTextDiv = this.nextElementSibling;
        if (accordionTextDiv.style.display === "block") {
          accordionTextDiv.style.display = "none";
        } else {
          accordionTextDiv.style.display = "block";
        }
      });
    }
  },
};
</script>

<style scoped>
button {
  background: white;
  padding: 16px;
  font-size: 17px;
  border: 0px solid transparent;
  color: black;
  width: 100%;
  text-align: left;
}

.active,
button:hover {
  background-color: lightsteelblue;
}

.accordion-text {
  background-color: #e2e9f3;
  display: none;

  padding: 16px;
  font-size: 17px;
  text-align: left;
}
</style>
